(defun c:mp (/ ss mp-errsav highlight exploded)  (setvar "cmdecho" 0)  (setq ss (ssget))  (setq	mp-errsav *error* highlight (getvar "highlight")
  ) (defun *error* (str)   (princ "\nError: ")  (princ str)  (if	exploded  (command "undo" "e" "u") ) (setvar "highlight" highlight)
    (setq *error* mp-errsav) (princ)) (setvar "highlight" 0) (if ss (progn  (expld ss) (setq dwgprefix (getvar "dwgprefix")) (setq dwgname (getvar "dwgname"))(setq dwgnameonly (substr dwgname 1 (- (strlen dwgname) 4))) (setq fullpath (strcat (chr 34) dwgprefix dwgnameonly  " MP.dxf"  (chr 34)
) ) (command "_dxfout" fullpath "_Version" "R12" "e" ss "" "16") (command "undo" "e" "u")(princ "\nStarting a new instance of MassPlus v7.0")	(princ "\nRun Calculate Section Properties from the MassPlus Menu")(princ "\nThen close the MassPlus application when finished") (startapp "C:\\Program Files (x86)\\CAD Systems Unlimited\\MassPlus v7.0\\mpwin" fullpath)
      (graphscr) ) ) (setq *error* mp-errsav) (setvar "highlight" highlight) (gc) (princ))(defun c:answer (/ x choice mp-errsav clayer aperture osmode highlight)  (setvar "cmdecho" 0)
  (setq	varlist	  '(aperture osmode highlight clayer)	evarlist  '("aperture" "osmode" "highlight") clayer	  (getvar "clayer")mp-errsav *error*
  )  (mapcar '(lambda (var evar) (set var (getvar evar))  )  varlist  evarlist ) (defun *error* (str) (princ "\nError: ") (princ str)
    (terpri)  (mapcar '(lambda (var value1) (setvar var (eval value1)) ) evarlist  varlist) (command "layer" "s" clayer "") (setq *error* mp-errsav)
    (gc) (princ) ) (setvar (car evarlist) 1) (foreach x (cdr evarlist) (setvar x 0)) (setq dwgprefix (getvar "dwgprefix")) (setq dwgname (getvar "dwgname"))
  (setq dwgnameonly (substr dwgname 1 (- (strlen dwgname) 4))) (setq fullpath (strcat dwgprefix dwgnameonly " Mp.dat")) (if (setq fp (open fullpath "r"))
    (progn (princ"\nMake sure you have run MassPlus - Calculate Section Properties" )  (princ "\nto get the most recent calculations instead of old values!" ) (princ"\nIf Centroidal Axes are not displayed correctly, " ) (princ"\nSet UCS Origin of Drawing to 0,0,0 and re-run MassPlus" 
      )   (princ "\n\nOptions: 1)Draw axes only  2)Print data only  3)Both "  ) (setq choice (getint))  (command "layer" "m" "massplus" "")
      (cond ((= choice 1) (repeat 45  (read-line fp)  ) (drawaxes))    ((= choice 2)  (printdata) ) ((= choice 3) (printdata) (drawaxes) )  (T(princ "\nValid choices are: 1, 2, or 3") ) ) (close fp)
    )  (princ "\nMassPlus calculations not found. \nRun MassPlus - Calculate Area Properties first!"  ) ) (mapcar '(lambda (var value2) (setvar var (eval value2))
	   )  evarlist  varlist ) (command "layer" "s" clayer "")  (redraw)  (princ))(defun changecolor (color / ent lastN ss) (setq	lastN lastent
ss  (ssadd)  ) (while (setq ent (entnext lastN))    (ssadd ent ss)    (setq lastN ent)  )  (command "change" ss "" "p" "c" color "")) (defun drawaxes	(/ cen to1 to2 text1 text2 textht rotation ent from to)
  (setq lastent (entlast))  (command "line"  (setq cen (read-line fp)) (setq to1 (read-line fp)) ""  ) (command "line" cen (setq to2 (read-line fp)) "")  (setq	text1	 (read-line fp)
	text2	 (read-line fp)	textht	 (read-line fp)	rotation (atof (read-line fp))  )  (command "text" text1 textht "0" "X")  (command "text" text2 textht "0" "Y")
  (changecolor "b")  (if (/= rotation 0.0)   (progn  (setq lastent (entlast))  (command "line" to2 cen to1 "")  (setq ent (entlast))
      (command "text" text1 textht "0" "U")    (command "text" text2 textht "0" "V")  (changecolor "r") (command "rotate" "p" "" cen rotation)
      (setq from (cdr (assoc 10 (setq ent (entget ent))))  to	 (cdr (assoc 11 ent)) ) ) ))(defun printdata (/ startpt height)  (setq	startpt	(getpoint "\nText start point ")
height	(read-line fp) )(command "text" startpt height "0" (command (read-line fp)))  (repeat 43  (command "text" "" (command (read-line fp)))
  ))(defun expld (ss / len ind ent elast)  (setq	len   (sslength ss)ind   0 elast (entlast) )  (while (< ind len)  (if	(or (= (cdr (assoc 0 (setq ent (entget (ssname ss ind)))))
"POLYLINE"  )   (= (cdr (assoc 0 (setq ent (entget (ssname ss ind))))) "LWPOLYLINE"  ) (= (cdr (assoc 0 ent)) "INSERT")	)  (command "explode" (cdr (assoc -1 ent)))
      (setq exploded T) )(setq ind (1+ ind))  )  (while (setq ent (entnext elast))(ssadd ent ss)   (setq elast ent) ))(princ "\nMassPlus loaded.")(gc)(princ)